/*
 * Copyright (c) 2015 Canon Inc.
 * Copyright (c) 2015 Igalia
 * Copyright (c) 2016 Apple Inc. All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * 
 */

// DO NOT EDIT THIS FILE. It is automatically generated from JavaScript files for
// builtins by the script: Source/JavaScriptCore/Scripts/generate-js-builtins.py

#include "config.h"
#include "WritableStreamBuiltins.h"

#include "WebCoreJSClientData.h"
#include <JavaScriptCore/HeapInlines.h>
#include <JavaScriptCore/IdentifierInlines.h>
#include <JavaScriptCore/Intrinsic.h>
#include <JavaScriptCore/JSCJSValueInlines.h>
#include <JavaScriptCore/JSCellInlines.h>
#include <JavaScriptCore/StructureInlines.h>
#include <JavaScriptCore/VM.h>

namespace WebCore {

const JSC::ConstructAbility s_writableStreamInitializeWritableStreamCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_writableStreamInitializeWritableStreamCodeConstructorKind = JSC::ConstructorKind::None;
const int s_writableStreamInitializeWritableStreamCodeLength = 2219;
static const JSC::Intrinsic s_writableStreamInitializeWritableStreamCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_writableStreamInitializeWritableStreamCode =
    "(function (underlyingSink, strategy)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "\n" \
    "    if (underlyingSink === @undefined)\n" \
    "        underlyingSink = { };\n" \
    "\n" \
    "    if (strategy === @undefined)\n" \
    "        strategy = { };\n" \
    "\n" \
    "    if (!@isObject(underlyingSink))\n" \
    "        @throwTypeError(\"WritableStream constructor takes an object as first argument\");\n" \
    "\n" \
    "    //\n" \
    "    if (@getByIdDirectPrivate(underlyingSink, \"WritableStream\")) {\n" \
    "        @privateInitializeWritableStream(this, underlyingSink);\n" \
    "\n" \
    "        const controller = new @WritableStreamDefaultController();\n" \
    "\n" \
    "        @setUpWritableStreamDefaultController(this, controller, underlyingSink.startAlgorithm, underlyingSink.writeAlgorithm, underlyingSink.closeAlgorithm, underlyingSink.abortAlgorithm, strategy.highWaterMark, strategy.sizeAlgorithm);\n" \
    "        return this;\n" \
    "    }\n" \
    "\n" \
    "    if (\"type\" in underlyingSink)\n" \
    "        @throwRangeError(\"Invalid type is specified\");\n" \
    "\n" \
    "    const sizeAlgorithm = @extractSizeAlgorithm(strategy);\n" \
    "    const highWaterMark = @extractHighWaterMark(strategy, 1);\n" \
    "\n" \
    "    const underlyingSinkDict = { };\n" \
    "    if (\"start\" in underlyingSink) {\n" \
    "        underlyingSinkDict[\"start\"] = underlyingSink[\"start\"];\n" \
    "        if (typeof underlyingSinkDict[\"start\"] !== \"function\")\n" \
    "            @throwTypeError(\"underlyingSink.start should be a function\");\n" \
    "    }\n" \
    "    if (\"write\" in underlyingSink) {\n" \
    "        underlyingSinkDict[\"write\"] = underlyingSink[\"write\"];\n" \
    "        if (typeof underlyingSinkDict[\"write\"] !== \"function\")\n" \
    "            @throwTypeError(\"underlyingSink.write should be a function\");\n" \
    "    }\n" \
    "    if (\"close\" in underlyingSink) {\n" \
    "        underlyingSinkDict[\"close\"] = underlyingSink[\"close\"];\n" \
    "        if (typeof underlyingSinkDict[\"close\"] !== \"function\")\n" \
    "            @throwTypeError(\"underlyingSink.close should be a function\");\n" \
    "    }\n" \
    "    if (\"abort\" in underlyingSink) {\n" \
    "        underlyingSinkDict[\"abort\"] = underlyingSink[\"abort\"];\n" \
    "        if (typeof underlyingSinkDict[\"abort\"] !== \"function\")\n" \
    "            @throwTypeError(\"underlyingSink.abort should be a function\");\n" \
    "    }\n" \
    "\n" \
    "    @privateInitializeWritableStream(this, underlyingSink);\n" \
    "    @setUpWritableStreamDefaultControllerFromUnderlyingSink(this, underlyingSink, underlyingSinkDict, highWaterMark, sizeAlgorithm);\n" \
    "\n" \
    "    return this;\n" \
    "})\n" \
;

const JSC::ConstructAbility s_writableStreamLockedCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_writableStreamLockedCodeConstructorKind = JSC::ConstructorKind::None;
const int s_writableStreamLockedCodeLength = 176;
static const JSC::Intrinsic s_writableStreamLockedCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_writableStreamLockedCode =
    "(function ()\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "\n" \
    "    if (!@isWritableStream(this))\n" \
    "        throw @makeThisTypeError(\"WritableStream\", \"locked\");\n" \
    "\n" \
    "    return @isWritableStreamLocked(this);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_writableStreamAbortCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_writableStreamAbortCodeConstructorKind = JSC::ConstructorKind::None;
const int s_writableStreamAbortCodeLength = 371;
static const JSC::Intrinsic s_writableStreamAbortCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_writableStreamAbortCode =
    "(function (reason)\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "\n" \
    "    if (!@isWritableStream(this))\n" \
    "        return @Promise.@reject(@makeThisTypeError(\"WritableStream\", \"abort\"));\n" \
    "\n" \
    "    if (@isWritableStreamLocked(this))\n" \
    "        return @Promise.@reject(@makeTypeError(\"WritableStream.abort method can only be used on non locked WritableStream\"));\n" \
    "\n" \
    "    return @writableStreamAbort(this, reason);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_writableStreamCloseCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_writableStreamCloseCodeConstructorKind = JSC::ConstructorKind::None;
const int s_writableStreamCloseCodeLength = 539;
static const JSC::Intrinsic s_writableStreamCloseCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_writableStreamCloseCode =
    "(function ()\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "\n" \
    "    if (!@isWritableStream(this))\n" \
    "        return @Promise.@reject(@makeThisTypeError(\"WritableStream\", \"close\"));\n" \
    "\n" \
    "    if (@isWritableStreamLocked(this))\n" \
    "        return @Promise.@reject(@makeTypeError(\"WritableStream.close method can only be used on non locked WritableStream\"));\n" \
    "\n" \
    "    if (@writableStreamCloseQueuedOrInFlight(this))\n" \
    "        return @Promise.@reject(@makeTypeError(\"WritableStream.close method can only be used on a being close WritableStream\"));\n" \
    "\n" \
    "    return @writableStreamClose(this);\n" \
    "})\n" \
;

const JSC::ConstructAbility s_writableStreamGetWriterCodeConstructAbility = JSC::ConstructAbility::CannotConstruct;
const JSC::ConstructorKind s_writableStreamGetWriterCodeConstructorKind = JSC::ConstructorKind::None;
const int s_writableStreamGetWriterCodeLength = 191;
static const JSC::Intrinsic s_writableStreamGetWriterCodeIntrinsic = JSC::NoIntrinsic;
const char* const s_writableStreamGetWriterCode =
    "(function ()\n" \
    "{\n" \
    "    \"use strict\";\n" \
    "\n" \
    "    if (!@isWritableStream(this))\n" \
    "        throw @makeThisTypeError(\"WritableStream\", \"getWriter\");\n" \
    "\n" \
    "    return @acquireWritableStreamDefaultWriter(this);\n" \
    "})\n" \
;


#define DEFINE_BUILTIN_GENERATOR(codeName, functionName, overriddenName, argumentCount) \
JSC::FunctionExecutable* codeName##Generator(JSC::VM& vm) \
{\
    JSVMClientData* clientData = static_cast<JSVMClientData*>(vm.clientData); \
    return clientData->builtinFunctions().writableStreamBuiltins().codeName##Executable()->link(vm, nullptr, clientData->builtinFunctions().writableStreamBuiltins().codeName##Source(), WTF::nullopt, s_##codeName##Intrinsic); \
}
WEBCORE_FOREACH_WRITABLESTREAM_BUILTIN_CODE(DEFINE_BUILTIN_GENERATOR)
#undef DEFINE_BUILTIN_GENERATOR


} // namespace WebCore
