/*
 * THIS FILE WAS AUTOMATICALLY GENERATED, DO NOT EDIT.
 *
 * Copyright (C) 2017 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebPreferences.h"

#include "WebPreferencesDefinitions.h"
#include "WebPreferencesKeys.h"

namespace WebKit {

const Vector<RefPtr<API::Object>>& WebPreferences::experimentalFeatures()
{
    static NeverDestroyed<Vector<RefPtr<API::Object>>> features(std::initializer_list<RefPtr<API::Object>> {
        API::ExperimentalFeature::create(":focus-visible pseudo-class", "FocusVisibleEnabled", "Enable the focus-indicated pseudo-class :focus-visible", DEFAULT_VALUE_FOR_FocusVisibleEnabled, false),
        API::ExperimentalFeature::create("@page CSS at-rule support", "PageAtRuleSupportEnabled", "Enable @page support", DEFAULT_VALUE_FOR_PageAtRuleSupportEnabled, false),
        API::ExperimentalFeature::create("Accessibility Object Model", "AccessibilityObjectModelEnabled", "Accessibility Object Model support", DEFAULT_VALUE_FOR_AccessibilityObjectModelEnabled, false),
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("Allow per media element speaker device selection", "PerElementSpeakerSelectionEnabled", "Allow per media element speaker device selection", DEFAULT_VALUE_FOR_PerElementSpeakerSelectionEnabled, false),
#endif
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("Allow speaker device selection", "ExposeSpeakersEnabled", "Allow speaker device selection", DEFAULT_VALUE_FOR_ExposeSpeakersEnabled, false),
#endif
        API::ExperimentalFeature::create("Aspect ratio of <img> from width and height", "AspectRatioOfImgFromWidthAndHeightEnabled", "Map HTML attributes width/height to the default aspect ratio of <img>", DEFAULT_VALUE_FOR_AspectRatioOfImgFromWidthAndHeightEnabled, false),
        API::ExperimentalFeature::create("Async clipboard API", "AsyncClipboardAPIEnabled", "Enable the async clipboard API", DEFAULT_VALUE_FOR_AsyncClipboardAPIEnabled, false),
        API::ExperimentalFeature::create("Automatic HTTPS upgrade", "HTTPSUpgradeEnabled", "Automatic HTTPS upgrade for known supported sites", DEFAULT_VALUE_FOR_HTTPSUpgradeEnabled, false),
        API::ExperimentalFeature::create("Blank anchor target implies rel=noopener", "BlankAnchorTargetImpliesNoOpenerEnabled", "target=_blank on anchor elements implies rel=noopener", DEFAULT_VALUE_FOR_BlankAnchorTargetImpliesNoOpenerEnabled, false),
        API::ExperimentalFeature::create("Block top-level redirects by third-party iframes", "ThirdPartyIframeRedirectBlockingEnabled", "Block top-level redirects by third-party iframes", DEFAULT_VALUE_FOR_ThirdPartyIframeRedirectBlockingEnabled, false),
        API::ExperimentalFeature::create("CSS Aspect Ratio", "AspectRatioEnabled", "Enable aspect-ratio CSS property", DEFAULT_VALUE_FOR_AspectRatioEnabled, false),
        API::ExperimentalFeature::create("CSS Custom Properties and Values API", "CSSCustomPropertiesAndValuesEnabled", "Enable CSS Custom Properties and Values API", DEFAULT_VALUE_FOR_CSSCustomPropertiesAndValuesEnabled, false),
        API::ExperimentalFeature::create("CSS Individual Transform Properties", "CSSIndividualTransformPropertiesEnabled", "Support for the translate, scale and rotate CSS properties", DEFAULT_VALUE_FOR_CSSIndividualTransformPropertiesEnabled, false),
        API::ExperimentalFeature::create("CSS Overscroll Behavior", "OverscrollBehaviorEnabled", "Enable CSS overscroll-behavior", DEFAULT_VALUE_FOR_OverscrollBehaviorEnabled, false),
#if ENABLE(CSS_PAINTING_API)
        API::ExperimentalFeature::create("CSS Painting API", "CSSPaintingAPIEnabled", "Enable the CSS Painting API", DEFAULT_VALUE_FOR_CSSPaintingAPIEnabled, false),
#endif
        API::ExperimentalFeature::create("CSS Relative Color Syntax", "CSSRelativeColorSyntaxEnabled", "Enable support for CSS Relative Color Syntax defined in CSS Color 5", DEFAULT_VALUE_FOR_CSSRelativeColorSyntaxEnabled, false),
        API::ExperimentalFeature::create("CSS Spring Animations", "SpringTimingFunctionEnabled", "CSS Spring Animation prototype", DEFAULT_VALUE_FOR_SpringTimingFunctionEnabled, false),
#if ENABLE(CSS_TYPED_OM)
        API::ExperimentalFeature::create("CSS Typed OM", "CSSTypedOMEnabled", "Enable the CSS Typed OM", DEFAULT_VALUE_FOR_CSSTypedOMEnabled, false),
#endif
        API::ExperimentalFeature::create("CSS color-mix()", "CSSColorMixEnabled", "Enable support for CSS color-mix() defined in CSS Color 5", DEFAULT_VALUE_FOR_CSSColorMixEnabled, false),
        API::ExperimentalFeature::create("CSSOM View Smooth Scrolling", "CSSOMViewSmoothScrollingEnabled", "Enable DOM API and CSS property for 'smooth' scroll behavior", DEFAULT_VALUE_FOR_CSSOMViewSmoothScrollingEnabled, false),
        API::ExperimentalFeature::create("Contact Picker API", "ContactPickerAPIEnabled", "Enable the Contact Picker API", DEFAULT_VALUE_FOR_ContactPickerAPIEnabled, false),
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
        API::ExperimentalFeature::create("CoreImage-Accelerated Filter Rendering", "CoreImageAcceleratedFilterRenderEnabled", "Accelerated CSS and SVG filter rendering using CoreImage", DEFAULT_VALUE_FOR_CoreImageAcceleratedFilterRenderEnabled, false),
#endif
        API::ExperimentalFeature::create("Defer async scripts until DOMContentLoaded or first-paint", "ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint", "Defer async scripts until DOMContentLoaded or first-paint", DEFAULT_VALUE_FOR_ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint, false),
        API::ExperimentalFeature::create("Dialog Element", "DialogElementEnabled", "Enable the Dialog Element", DEFAULT_VALUE_FOR_DialogElementEnabled, false),
        API::ExperimentalFeature::create("Disable Full 3rd-Party Cookie Blocking (ITP)", "IsThirdPartyCookieBlockingDisabled", "Disable full third-party cookie blocking when Intelligent Tracking Prevention is enabled", DEFAULT_VALUE_FOR_IsThirdPartyCookieBlockingDisabled, false),
#if HAVE(CELESTIAL)
        API::ExperimentalFeature::create("Disable Media Experience PID Inheritance", "DisableMediaExperiencePIDInheritance", "Disable Media Experience PID Inheritance", DEFAULT_VALUE_FOR_DisableMediaExperiencePIDInheritance, false),
#endif
        API::ExperimentalFeature::create("Disable Removal of Non-Cookie Data After 7 Days of No User Interaction (ITP)", "IsFirstPartyWebsiteDataRemovalDisabled", "Disable removal of all non-cookie website data after seven days of no user interaction when Intelligent Tracking Prevention is enabled", DEFAULT_VALUE_FOR_IsFirstPartyWebsiteDataRemovalDisabled, false),
        API::ExperimentalFeature::create("Disable WebSQL", "WebSQLDisabled", "Disable WebSQL", DEFAULT_VALUE_FOR_WebSQLDisabled, false),
        API::ExperimentalFeature::create("Disallow sync XHR during page dismissal", "DisallowSyncXHRDuringPageDismissalEnabled", "Disallow synchronous XMLHttpRequest during page dismissal", DEFAULT_VALUE_FOR_DisallowSyncXHRDuringPageDismissalEnabled, false),
#if HAVE(NETWORK_LOADER)
        API::ExperimentalFeature::create("Experimental network loader", "CFNetworkNetworkLoaderEnabled", "Enable experimental network loader", DEFAULT_VALUE_FOR_CFNetworkNetworkLoaderEnabled, false),
#endif
        API::ExperimentalFeature::create("Fetch API Request KeepAlive", "FetchAPIKeepAliveEnabled", "Enable Fetch API Request KeepAlive", DEFAULT_VALUE_FOR_FetchAPIKeepAliveEnabled, false),
#if ENABLE(GPU_PROCESS) && !USE(GSTREAMER)
        API::ExperimentalFeature::create("GPU Process: Media", "UseGPUProcessForMediaEnabled", "Do all media loading and playback in the GPU Process", DEFAULT_VALUE_FOR_UseGPUProcessForMediaEnabled, false),
#endif
#if ENABLE(VIDEO)
        API::ExperimentalFeature::create("Generic Text Track Cue API", "GenericCueAPIEnabled", "Enable Generic Text Track Cue API", DEFAULT_VALUE_FOR_GenericCueAPIEnabled, false),
#endif
        API::ExperimentalFeature::create("HDR Media Capabilities", "HDRMediaCapabilitiesEnabled", "HDR Media Capabilities", DEFAULT_VALUE_FOR_HDRMediaCapabilitiesEnabled, false),
#if ENABLE(MODEL_ELEMENT)
        API::ExperimentalFeature::create("HTML <model> element", "ModelElementEnabled", "HTML <model> element", DEFAULT_VALUE_FOR_ModelElementEnabled, false),
#endif
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
        API::ExperimentalFeature::create("HTTP/3", "HTTP3Enabled", "Enable HTTP/3", DEFAULT_VALUE_FOR_HTTP3Enabled, false),
#endif
        API::ExperimentalFeature::create("Highlight API", "HighlightAPIEnabled", "Highlight API support", DEFAULT_VALUE_FOR_HighlightAPIEnabled, false),
        API::ExperimentalFeature::create("ImageBitmap", "ImageBitmapEnabled", "Support for the ImageBitmap APIs", DEFAULT_VALUE_FOR_ImageBitmapEnabled, false),
        API::ExperimentalFeature::create("In-Process Cookie Cache", "InProcessCookieCacheEnabled", "In-Process DOM Cookie Cache", DEFAULT_VALUE_FOR_InProcessCookieCacheEnabled, false),
#if HAVE(INCREMENTAL_PDF_APIS)
        API::ExperimentalFeature::create("Incremental PDF Loading", "IncrementalPDFLoadingEnabled", "Enable Incremental PDF Loading on supported platforms", DEFAULT_VALUE_FOR_IncrementalPDFLoadingEnabled, false),
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        API::ExperimentalFeature::create("Intersection Observer", "IntersectionObserverEnabled", "Enable Intersection Observer support", DEFAULT_VALUE_FOR_IntersectionObserverEnabled, false),
#endif
        API::ExperimentalFeature::create("IsLoggedIn web API", "IsLoggedInAPIEnabled", "Enable the proposed IsLoggedIn web API", DEFAULT_VALUE_FOR_IsLoggedInAPIEnabled, false),
        API::ExperimentalFeature::create("Lazy iframe loading", "LazyIframeLoadingEnabled", "Enable lazy iframe loading support", DEFAULT_VALUE_FOR_LazyIframeLoadingEnabled, false),
        API::ExperimentalFeature::create("Lazy image loading", "LazyImageLoadingEnabled", "Enable lazy image loading support", DEFAULT_VALUE_FOR_LazyImageLoadingEnabled, false),
        API::ExperimentalFeature::create("Link preload responsive images", "LinkPreloadResponsiveImagesEnabled", "Enable link preload responsive images", DEFAULT_VALUE_FOR_LinkPreloadResponsiveImagesEnabled, false),
        API::ExperimentalFeature::create("LinkPrefetch", "LinkPrefetchEnabled", "Enable LinkedPrefetch", DEFAULT_VALUE_FOR_LinkPrefetchEnabled, false),
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        API::ExperimentalFeature::create("Mask WebGL Strings", "MaskWebGLStringsEnabled", "Mask WebGL Vendor, Renderer, Shader Language Strings", DEFAULT_VALUE_FOR_MaskWebGLStringsEnabled, false),
#endif
        API::ExperimentalFeature::create("MathML Core", "CoreMathMLEnabled", "Disable features removed from the MathML Core spec.", DEFAULT_VALUE_FOR_CoreMathMLEnabled, false),
        API::ExperimentalFeature::create("Media Capabilities Extensions", "MediaCapabilitiesExtensionsEnabled", "Media Capabilities Extensions", DEFAULT_VALUE_FOR_MediaCapabilitiesExtensionsEnabled, false),
#if ENABLE(MEDIA_SESSION)
        API::ExperimentalFeature::create("Media Session API", "MediaSessionEnabled", "Media Session API", DEFAULT_VALUE_FOR_MediaSessionEnabled, false),
#endif
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("MediaRecorder", "MediaRecorderEnabled", "MediaRecorder", DEFAULT_VALUE_FOR_MediaRecorderEnabled, false),
#endif
#if ENABLE(WEB_AUDIO)
        API::ExperimentalFeature::create("Modern WebAudio API", "ModernUnprefixedWebAudioEnabled", "Modern and unprefixed WebAudio API", DEFAULT_VALUE_FOR_ModernUnprefixedWebAudioEnabled, false),
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
        API::ExperimentalFeature::create("NSURLSession WebSocket", "IsNSURLSessionWebSocketEnabled", "Use NSURLSession WebSocket API", DEFAULT_VALUE_FOR_IsNSURLSessionWebSocketEnabled, false),
#endif
#if ENABLE(OPUS)
        API::ExperimentalFeature::create("Opus audio decoder", "OpusDecoderEnabled", "Enable Opus audio decoder", DEFAULT_VALUE_FOR_OpusDecoderEnabled, false),
#endif
        API::ExperimentalFeature::create("Paint Timing", "PaintTimingEnabled", "Enable PaintTiming API", DEFAULT_VALUE_FOR_PaintTimingEnabled, false),
        API::ExperimentalFeature::create("Private Click Measurement Debug Mode", "PrivateClickMeasurementDebugModeEnabled", "Enable Private Click Measurement Debug Mode", DEFAULT_VALUE_FOR_PrivateClickMeasurementDebugModeEnabled, false),
        API::ExperimentalFeature::create("Private Click Measurement Fraud Prevention", "PrivateClickMeasurementFraudPreventionEnabled", "Enable Private Click Measurement Fraud Prevention", DEFAULT_VALUE_FOR_PrivateClickMeasurementFraudPreventionEnabled, false),
        API::ExperimentalFeature::create("Quirk to prevent delayed initial painting on sites using Google's Anti-Flicker optimization", "GoogleAntiFlickerOptimizationQuirkEnabled", "Quirk to prevent delayed initial painting on sites using Google's Anti-Flicker optimization", DEFAULT_VALUE_FOR_GoogleAntiFlickerOptimizationQuirkEnabled, false),
        API::ExperimentalFeature::create("ReadableByteStream", "ReadableByteStreamAPIEnabled", "Enable Readable Byte Streams", DEFAULT_VALUE_FOR_ReadableByteStreamAPIEnabled, false),
        API::ExperimentalFeature::create("Referrer Policy attribute", "ReferrerPolicyAttributeEnabled", "Enable Referrer Policy attribute", DEFAULT_VALUE_FOR_ReferrerPolicyAttributeEnabled, false),
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        API::ExperimentalFeature::create("Remote Playback API", "RemotePlaybackEnabled", "Enable Remote Playback API", DEFAULT_VALUE_FOR_RemotePlaybackEnabled, false),
#endif
#if ENABLE(RESIZE_OBSERVER)
        API::ExperimentalFeature::create("Resize Observer", "ResizeObserverEnabled", "Enable Resize Observer support", DEFAULT_VALUE_FOR_ResizeObserverEnabled, false),
#endif
        API::ExperimentalFeature::create("SameSite strict enforcement (ITP)", "IsSameSiteStrictEnforcementEnabled", "Enable SameSite strict enforcement to mitigate bounce tracking", DEFAULT_VALUE_FOR_IsSameSiteStrictEnforcementEnabled, false),
#if ENABLE(MEDIA_STREAM)
        API::ExperimentalFeature::create("ScreenCapture", "ScreenCaptureEnabled", "Enable ScreenCapture", DEFAULT_VALUE_FOR_ScreenCaptureEnabled, false),
#endif
        API::ExperimentalFeature::create("Server Timing", "ServerTimingEnabled", "Enable Server Timing API", DEFAULT_VALUE_FOR_ServerTimingEnabled, false),
        API::ExperimentalFeature::create("SpeechRecognition API", "SpeechRecognitionEnabled", "Enable SpeechRecognition of WebSpeech API", DEFAULT_VALUE_FOR_SpeechRecognitionEnabled, false),
        API::ExperimentalFeature::create("Swap Processes on Cross-Site Navigation", "ProcessSwapOnCrossSiteNavigationEnabled", "Swap WebContent Processes on cross-site navigations", DEFAULT_VALUE_FOR_ProcessSwapOnCrossSiteNavigationEnabled, false),
        API::ExperimentalFeature::create("Synthetic Editing Commands", "SyntheticEditingCommandsEnabled", "Enable Synthetic Editing Commands", DEFAULT_VALUE_FOR_SyntheticEditingCommandsEnabled, false),
        API::ExperimentalFeature::create("TransformStream API", "TransformStreamAPIEnabled", "Enable Transform Stream API", DEFAULT_VALUE_FOR_TransformStreamAPIEnabled, false),
        API::ExperimentalFeature::create("UserGesture Promise Propagation", "UserGesturePromisePropagationEnabled", "UserGesture Promise Propagation", DEFAULT_VALUE_FOR_UserGesturePromisePropagationEnabled, false),
#if ENABLE(VP9)
        API::ExperimentalFeature::create("VP8 decoder", "VP8DecoderEnabled", "Enable VP8 decoder", DEFAULT_VALUE_FOR_VP8DecoderEnabled, false),
#endif
#if ENABLE(VP9)
        API::ExperimentalFeature::create("VP9 SW decoder on battery", "VP9SWDecoderEnabledOnBattery", "Enable VP9 SW decoder on battery", DEFAULT_VALUE_FOR_VP9SWDecoderEnabledOnBattery, false),
#endif
#if ENABLE(VP9)
        API::ExperimentalFeature::create("VP9 decoder", "VP9DecoderEnabled", "Enable VP9 decoder", DEFAULT_VALUE_FOR_VP9DecoderEnabled, false),
#endif
        API::ExperimentalFeature::create("Visual Viewport API", "VisualViewportAPIEnabled", "Enable Visual Viewport API", DEFAULT_VALUE_FOR_VisualViewportAPIEnabled, false),
#if ENABLE(VORBIS)
        API::ExperimentalFeature::create("Vorbis audio decoder", "VorbisDecoderEnabled", "Enable Vorbis audio decoder", DEFAULT_VALUE_FOR_VorbisDecoderEnabled, false),
#endif
        API::ExperimentalFeature::create("Web Animations composite operations", "WebAnimationsCompositeOperationsEnabled", "Support for the CompositeOperation enum and properties consuming it", DEFAULT_VALUE_FOR_WebAnimationsCompositeOperationsEnabled, false),
        API::ExperimentalFeature::create("Web Animations mutable timelines", "WebAnimationsMutableTimelinesEnabled", "Support for setting the timeline property of an Animation object", DEFAULT_VALUE_FOR_WebAnimationsMutableTimelinesEnabled, false),
#if ENABLE(WEB_AUTHN)
        API::ExperimentalFeature::create("Web Authentication Modern", "WebAuthenticationModernEnabled", "Enable Modern Web Authentication support", DEFAULT_VALUE_FOR_WebAuthenticationModernEnabled, false),
#endif
#if ENABLE(WEB_AUTHN)
        API::ExperimentalFeature::create("Web Authentication", "WebAuthenticationEnabled", "Enable Web Authentication support", DEFAULT_VALUE_FOR_WebAuthenticationEnabled, false),
#endif
        API::ExperimentalFeature::create("Web Share API Level 2", "WebShareFileAPIEnabled", "Enable level 2 of Web Share API", DEFAULT_VALUE_FOR_WebShareFileAPIEnabled, false),
#if ENABLE(WEB_AUDIO)
        API::ExperimentalFeature::create("WebAudio AudioWorklet API", "AudioWorkletEnabled", "WebAudio AudioWorklet API", DEFAULT_VALUE_FOR_AudioWorkletEnabled, false),
#endif
#if ENABLE(WEBGL2)
        API::ExperimentalFeature::create("WebGL 2.0", "WebGL2Enabled", "WebGL 2 prototype", DEFAULT_VALUE_FOR_WebGL2Enabled, false),
#endif
#if ENABLE(WEBGPU)
        API::ExperimentalFeature::create("WebGPU", "WebGPUEnabled", "WebGPU Sketch prototype", DEFAULT_VALUE_FOR_WebGPUEnabled, false),
#endif
#if ENABLE(MEDIA_SOURCE) && ENABLE(VP9)
        API::ExperimentalFeature::create("WebM MSE parser", "WebMParserEnabled", "Enable WebM MSE parser", DEFAULT_VALUE_FOR_WebMParserEnabled, false),
#endif
#if ENABLE(WEBM_FORMAT_READER)
        API::ExperimentalFeature::create("WebM format reader", "WebMFormatReaderEnabled", "Enable MediaToolbox format reader plug-in for WebM", DEFAULT_VALUE_FOR_WebMFormatReaderEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC H264 LowLatency encoder", "WebRTCH264LowLatencyEncoderEnabled", "Enable H264 LowLatency encoder", DEFAULT_VALUE_FOR_WebRTCH264LowLatencyEncoderEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC H265 codec", "WebRTCH265CodecEnabled", "Enable WebRTC H265 codec", DEFAULT_VALUE_FOR_WebRTCH265CodecEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC Insertable Streams API", "WebRTCInsertableStreamsEnabled", "Enable WebRTC Insertable Streams API", DEFAULT_VALUE_FOR_WebRTCInsertableStreamsEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC Platform Codecs in GPU Process", "WebRTCPlatformCodecsInGPUProcessEnabled", "Enable WebRTC Platform Codecs in GPU Process", DEFAULT_VALUE_FOR_WebRTCPlatformCodecsInGPUProcessEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC Platform Sockets", "WebRTCPlatformSocketsEnabled", "Enable WebRTC Platform Sockets", DEFAULT_VALUE_FOR_WebRTCPlatformSocketsEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC VP9 profile 0 codec", "WebRTCVP9Profile0CodecEnabled", "Enable WebRTC VP9 profile 0 codec", DEFAULT_VALUE_FOR_WebRTCVP9Profile0CodecEnabled, false),
#endif
#if ENABLE(WEB_RTC)
        API::ExperimentalFeature::create("WebRTC VP9 profile 2 codec", "WebRTCVP9Profile2CodecEnabled", "Enable WebRTC VP9 profile 2 codec", DEFAULT_VALUE_FOR_WebRTCVP9Profile2CodecEnabled, false),
#endif
#if ENABLE(WEBXR)
        API::ExperimentalFeature::create("WebXR Device API", "WebXREnabled", "Adds support for accessing virtual reality (VR) and augmented reality (AR) devices, including sensors and head-mounted displays, on the Web", DEFAULT_VALUE_FOR_WebXREnabled, false),
#endif
        API::ExperimentalFeature::create("Wheel Event gestures become non-blocking", "WheelEventGesturesBecomeNonBlocking", "preventDefault() is only allowed on the first wheel event in a gesture", DEFAULT_VALUE_FOR_WheelEventGesturesBecomeNonBlocking, false),
        API::ExperimentalFeature::create("Wheel Event listeners on the root made passive", "PassiveWheelListenersAsDefaultOnDocument", "Force wheel event listeners registered on the window, document or body to be passive", DEFAULT_VALUE_FOR_PassiveWheelListenersAsDefaultOnDocument, false),
        API::ExperimentalFeature::create("WritableStream API", "WritableStreamAPIEnabled", "Enable Writable Stream API", DEFAULT_VALUE_FOR_WritableStreamAPIEnabled, false),
        API::ExperimentalFeature::create("requestIdleCallback", "RequestIdleCallbackEnabled", "Enable requestIdleCallback support", DEFAULT_VALUE_FOR_RequestIdleCallbackEnabled, false),
    });

    return features;
}

bool WebPreferences::isFeatureEnabled(const API::ExperimentalFeature& feature) const
{
    struct FeatureGetterMapping {
        const char* name;
        bool (WebPreferences::*function) () const;
    };

    static FeatureGetterMapping getters[] = {
        { "FocusVisibleEnabled", &WebPreferences::focusVisibleEnabled },
        { "PageAtRuleSupportEnabled", &WebPreferences::pageAtRuleSupportEnabled },
        { "AccessibilityObjectModelEnabled", &WebPreferences::accessibilityObjectModelEnabled },
#if ENABLE(MEDIA_STREAM)
        { "PerElementSpeakerSelectionEnabled", &WebPreferences::perElementSpeakerSelectionEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "ExposeSpeakersEnabled", &WebPreferences::exposeSpeakersEnabled },
#endif
        { "AspectRatioOfImgFromWidthAndHeightEnabled", &WebPreferences::aspectRatioOfImgFromWidthAndHeightEnabled },
        { "AsyncClipboardAPIEnabled", &WebPreferences::asyncClipboardAPIEnabled },
        { "HTTPSUpgradeEnabled", &WebPreferences::httpSUpgradeEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::blankAnchorTargetImpliesNoOpenerEnabled },
        { "ThirdPartyIframeRedirectBlockingEnabled", &WebPreferences::thirdPartyIframeRedirectBlockingEnabled },
        { "AspectRatioEnabled", &WebPreferences::aspectRatioEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::cssCustomPropertiesAndValuesEnabled },
        { "CSSIndividualTransformPropertiesEnabled", &WebPreferences::cssIndividualTransformPropertiesEnabled },
        { "OverscrollBehaviorEnabled", &WebPreferences::overscrollBehaviorEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::cssPaintingAPIEnabled },
#endif
        { "CSSRelativeColorSyntaxEnabled", &WebPreferences::cssRelativeColorSyntaxEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::springTimingFunctionEnabled },
#if ENABLE(CSS_TYPED_OM)
        { "CSSTypedOMEnabled", &WebPreferences::cssTypedOMEnabled },
#endif
        { "CSSColorMixEnabled", &WebPreferences::cssColorMixEnabled },
        { "CSSOMViewSmoothScrollingEnabled", &WebPreferences::cssOMViewSmoothScrollingEnabled },
        { "ContactPickerAPIEnabled", &WebPreferences::contactPickerAPIEnabled },
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
        { "CoreImageAcceleratedFilterRenderEnabled", &WebPreferences::coreImageAcceleratedFilterRenderEnabled },
#endif
        { "ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint", &WebPreferences::shouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint },
        { "DialogElementEnabled", &WebPreferences::dialogElementEnabled },
        { "IsThirdPartyCookieBlockingDisabled", &WebPreferences::isThirdPartyCookieBlockingDisabled },
#if HAVE(CELESTIAL)
        { "DisableMediaExperiencePIDInheritance", &WebPreferences::disableMediaExperiencePIDInheritance },
#endif
        { "IsFirstPartyWebsiteDataRemovalDisabled", &WebPreferences::isFirstPartyWebsiteDataRemovalDisabled },
        { "WebSQLDisabled", &WebPreferences::webSQLDisabled },
        { "DisallowSyncXHRDuringPageDismissalEnabled", &WebPreferences::disallowSyncXHRDuringPageDismissalEnabled },
#if HAVE(NETWORK_LOADER)
        { "CFNetworkNetworkLoaderEnabled", &WebPreferences::cFNetworkNetworkLoaderEnabled },
#endif
        { "FetchAPIKeepAliveEnabled", &WebPreferences::fetchAPIKeepAliveEnabled },
#if ENABLE(GPU_PROCESS) && !USE(GSTREAMER)
        { "UseGPUProcessForMediaEnabled", &WebPreferences::useGPUProcessForMediaEnabled },
#endif
#if ENABLE(VIDEO)
        { "GenericCueAPIEnabled", &WebPreferences::genericCueAPIEnabled },
#endif
        { "HDRMediaCapabilitiesEnabled", &WebPreferences::hDRMediaCapabilitiesEnabled },
#if ENABLE(MODEL_ELEMENT)
        { "ModelElementEnabled", &WebPreferences::modelElementEnabled },
#endif
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
        { "HTTP3Enabled", &WebPreferences::http3Enabled },
#endif
        { "HighlightAPIEnabled", &WebPreferences::highlightAPIEnabled },
        { "ImageBitmapEnabled", &WebPreferences::imageBitmapEnabled },
        { "InProcessCookieCacheEnabled", &WebPreferences::inProcessCookieCacheEnabled },
#if HAVE(INCREMENTAL_PDF_APIS)
        { "IncrementalPDFLoadingEnabled", &WebPreferences::incrementalPDFLoadingEnabled },
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::intersectionObserverEnabled },
#endif
        { "IsLoggedInAPIEnabled", &WebPreferences::isLoggedInAPIEnabled },
        { "LazyIframeLoadingEnabled", &WebPreferences::lazyIframeLoadingEnabled },
        { "LazyImageLoadingEnabled", &WebPreferences::lazyImageLoadingEnabled },
        { "LinkPreloadResponsiveImagesEnabled", &WebPreferences::linkPreloadResponsiveImagesEnabled },
        { "LinkPrefetchEnabled", &WebPreferences::linkPrefetchEnabled },
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        { "MaskWebGLStringsEnabled", &WebPreferences::maskWebGLStringsEnabled },
#endif
        { "CoreMathMLEnabled", &WebPreferences::coreMathMLEnabled },
        { "MediaCapabilitiesExtensionsEnabled", &WebPreferences::mediaCapabilitiesExtensionsEnabled },
#if ENABLE(MEDIA_SESSION)
        { "MediaSessionEnabled", &WebPreferences::mediaSessionEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::mediaRecorderEnabled },
#endif
#if ENABLE(WEB_AUDIO)
        { "ModernUnprefixedWebAudioEnabled", &WebPreferences::modernUnprefixedWebAudioEnabled },
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
        { "IsNSURLSessionWebSocketEnabled", &WebPreferences::isNSURLSessionWebSocketEnabled },
#endif
#if ENABLE(OPUS)
        { "OpusDecoderEnabled", &WebPreferences::opusDecoderEnabled },
#endif
        { "PaintTimingEnabled", &WebPreferences::paintTimingEnabled },
        { "PrivateClickMeasurementDebugModeEnabled", &WebPreferences::privateClickMeasurementDebugModeEnabled },
        { "PrivateClickMeasurementFraudPreventionEnabled", &WebPreferences::privateClickMeasurementFraudPreventionEnabled },
        { "GoogleAntiFlickerOptimizationQuirkEnabled", &WebPreferences::googleAntiFlickerOptimizationQuirkEnabled },
        { "ReadableByteStreamAPIEnabled", &WebPreferences::readableByteStreamAPIEnabled },
        { "ReferrerPolicyAttributeEnabled", &WebPreferences::referrerPolicyAttributeEnabled },
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        { "RemotePlaybackEnabled", &WebPreferences::remotePlaybackEnabled },
#endif
#if ENABLE(RESIZE_OBSERVER)
        { "ResizeObserverEnabled", &WebPreferences::resizeObserverEnabled },
#endif
        { "IsSameSiteStrictEnforcementEnabled", &WebPreferences::isSameSiteStrictEnforcementEnabled },
#if ENABLE(MEDIA_STREAM)
        { "ScreenCaptureEnabled", &WebPreferences::screenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::serverTimingEnabled },
        { "SpeechRecognitionEnabled", &WebPreferences::speechRecognitionEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::processSwapOnCrossSiteNavigationEnabled },
        { "SyntheticEditingCommandsEnabled", &WebPreferences::syntheticEditingCommandsEnabled },
        { "TransformStreamAPIEnabled", &WebPreferences::transformStreamAPIEnabled },
        { "UserGesturePromisePropagationEnabled", &WebPreferences::userGesturePromisePropagationEnabled },
#if ENABLE(VP9)
        { "VP8DecoderEnabled", &WebPreferences::vp8DecoderEnabled },
#endif
#if ENABLE(VP9)
        { "VP9SWDecoderEnabledOnBattery", &WebPreferences::vp9SWDecoderEnabledOnBattery },
#endif
#if ENABLE(VP9)
        { "VP9DecoderEnabled", &WebPreferences::vp9DecoderEnabled },
#endif
        { "VisualViewportAPIEnabled", &WebPreferences::visualViewportAPIEnabled },
#if ENABLE(VORBIS)
        { "VorbisDecoderEnabled", &WebPreferences::vorbisDecoderEnabled },
#endif
        { "WebAnimationsCompositeOperationsEnabled", &WebPreferences::webAnimationsCompositeOperationsEnabled },
        { "WebAnimationsMutableTimelinesEnabled", &WebPreferences::webAnimationsMutableTimelinesEnabled },
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationModernEnabled", &WebPreferences::webAuthenticationModernEnabled },
#endif
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationEnabled", &WebPreferences::webAuthenticationEnabled },
#endif
        { "WebShareFileAPIEnabled", &WebPreferences::webShareFileAPIEnabled },
#if ENABLE(WEB_AUDIO)
        { "AudioWorkletEnabled", &WebPreferences::audioWorkletEnabled },
#endif
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::webGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::webGPUEnabled },
#endif
#if ENABLE(MEDIA_SOURCE) && ENABLE(VP9)
        { "WebMParserEnabled", &WebPreferences::webMParserEnabled },
#endif
#if ENABLE(WEBM_FORMAT_READER)
        { "WebMFormatReaderEnabled", &WebPreferences::webMFormatReaderEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH264LowLatencyEncoderEnabled", &WebPreferences::webRTCH264LowLatencyEncoderEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH265CodecEnabled", &WebPreferences::webRTCH265CodecEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCInsertableStreamsEnabled", &WebPreferences::webRTCInsertableStreamsEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCPlatformCodecsInGPUProcessEnabled", &WebPreferences::webRTCPlatformCodecsInGPUProcessEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCPlatformSocketsEnabled", &WebPreferences::webRTCPlatformSocketsEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP9Profile0CodecEnabled", &WebPreferences::webRTCVP9Profile0CodecEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP9Profile2CodecEnabled", &WebPreferences::webRTCVP9Profile2CodecEnabled },
#endif
#if ENABLE(WEBXR)
        { "WebXREnabled", &WebPreferences::webXREnabled },
#endif
        { "WheelEventGesturesBecomeNonBlocking", &WebPreferences::wheelEventGesturesBecomeNonBlocking },
        { "PassiveWheelListenersAsDefaultOnDocument", &WebPreferences::passiveWheelListenersAsDefaultOnDocument },
        { "WritableStreamAPIEnabled", &WebPreferences::writableStreamAPIEnabled },
        { "RequestIdleCallbackEnabled", &WebPreferences::requestIdleCallbackEnabled },
    };

    const String& key = feature.key();

    for (auto& getter : getters) {
        if (key == getter.name)
            return (this->*getter.function)();
    }

    return false;
}

void WebPreferences::setFeatureEnabled(const API::ExperimentalFeature& feature, bool value)
{
    setExperimentalFeatureEnabledForKey(feature.key(), value);
}

void WebPreferences::setExperimentalFeatureEnabledForKey(const String& key, bool value)
{
    struct FeatureSetterMapping {
        const char* name;
        void (WebPreferences::*function) (const bool&);
    };

    static FeatureSetterMapping setters[] = {
        { "FocusVisibleEnabled", &WebPreferences::setFocusVisibleEnabled },
        { "PageAtRuleSupportEnabled", &WebPreferences::setPageAtRuleSupportEnabled },
        { "AccessibilityObjectModelEnabled", &WebPreferences::setAccessibilityObjectModelEnabled },
#if ENABLE(MEDIA_STREAM)
        { "PerElementSpeakerSelectionEnabled", &WebPreferences::setPerElementSpeakerSelectionEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "ExposeSpeakersEnabled", &WebPreferences::setExposeSpeakersEnabled },
#endif
        { "AspectRatioOfImgFromWidthAndHeightEnabled", &WebPreferences::setAspectRatioOfImgFromWidthAndHeightEnabled },
        { "AsyncClipboardAPIEnabled", &WebPreferences::setAsyncClipboardAPIEnabled },
        { "HTTPSUpgradeEnabled", &WebPreferences::setHTTPSUpgradeEnabled },
        { "BlankAnchorTargetImpliesNoOpenerEnabled", &WebPreferences::setBlankAnchorTargetImpliesNoOpenerEnabled },
        { "ThirdPartyIframeRedirectBlockingEnabled", &WebPreferences::setThirdPartyIframeRedirectBlockingEnabled },
        { "AspectRatioEnabled", &WebPreferences::setAspectRatioEnabled },
        { "CSSCustomPropertiesAndValuesEnabled", &WebPreferences::setCSSCustomPropertiesAndValuesEnabled },
        { "CSSIndividualTransformPropertiesEnabled", &WebPreferences::setCSSIndividualTransformPropertiesEnabled },
        { "OverscrollBehaviorEnabled", &WebPreferences::setOverscrollBehaviorEnabled },
#if ENABLE(CSS_PAINTING_API)
        { "CSSPaintingAPIEnabled", &WebPreferences::setCSSPaintingAPIEnabled },
#endif
        { "CSSRelativeColorSyntaxEnabled", &WebPreferences::setCSSRelativeColorSyntaxEnabled },
        { "SpringTimingFunctionEnabled", &WebPreferences::setSpringTimingFunctionEnabled },
#if ENABLE(CSS_TYPED_OM)
        { "CSSTypedOMEnabled", &WebPreferences::setCSSTypedOMEnabled },
#endif
        { "CSSColorMixEnabled", &WebPreferences::setCSSColorMixEnabled },
        { "CSSOMViewSmoothScrollingEnabled", &WebPreferences::setCSSOMViewSmoothScrollingEnabled },
        { "ContactPickerAPIEnabled", &WebPreferences::setContactPickerAPIEnabled },
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
        { "CoreImageAcceleratedFilterRenderEnabled", &WebPreferences::setCoreImageAcceleratedFilterRenderEnabled },
#endif
        { "ShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint", &WebPreferences::setShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint },
        { "DialogElementEnabled", &WebPreferences::setDialogElementEnabled },
        { "IsThirdPartyCookieBlockingDisabled", &WebPreferences::setIsThirdPartyCookieBlockingDisabled },
#if HAVE(CELESTIAL)
        { "DisableMediaExperiencePIDInheritance", &WebPreferences::setDisableMediaExperiencePIDInheritance },
#endif
        { "IsFirstPartyWebsiteDataRemovalDisabled", &WebPreferences::setIsFirstPartyWebsiteDataRemovalDisabled },
        { "WebSQLDisabled", &WebPreferences::setWebSQLDisabled },
        { "DisallowSyncXHRDuringPageDismissalEnabled", &WebPreferences::setDisallowSyncXHRDuringPageDismissalEnabled },
#if HAVE(NETWORK_LOADER)
        { "CFNetworkNetworkLoaderEnabled", &WebPreferences::setCFNetworkNetworkLoaderEnabled },
#endif
        { "FetchAPIKeepAliveEnabled", &WebPreferences::setFetchAPIKeepAliveEnabled },
#if ENABLE(GPU_PROCESS) && !USE(GSTREAMER)
        { "UseGPUProcessForMediaEnabled", &WebPreferences::setUseGPUProcessForMediaEnabled },
#endif
#if ENABLE(VIDEO)
        { "GenericCueAPIEnabled", &WebPreferences::setGenericCueAPIEnabled },
#endif
        { "HDRMediaCapabilitiesEnabled", &WebPreferences::setHDRMediaCapabilitiesEnabled },
#if ENABLE(MODEL_ELEMENT)
        { "ModelElementEnabled", &WebPreferences::setModelElementEnabled },
#endif
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
        { "HTTP3Enabled", &WebPreferences::setHTTP3Enabled },
#endif
        { "HighlightAPIEnabled", &WebPreferences::setHighlightAPIEnabled },
        { "ImageBitmapEnabled", &WebPreferences::setImageBitmapEnabled },
        { "InProcessCookieCacheEnabled", &WebPreferences::setInProcessCookieCacheEnabled },
#if HAVE(INCREMENTAL_PDF_APIS)
        { "IncrementalPDFLoadingEnabled", &WebPreferences::setIncrementalPDFLoadingEnabled },
#endif
#if ENABLE(INTERSECTION_OBSERVER)
        { "IntersectionObserverEnabled", &WebPreferences::setIntersectionObserverEnabled },
#endif
        { "IsLoggedInAPIEnabled", &WebPreferences::setIsLoggedInAPIEnabled },
        { "LazyIframeLoadingEnabled", &WebPreferences::setLazyIframeLoadingEnabled },
        { "LazyImageLoadingEnabled", &WebPreferences::setLazyImageLoadingEnabled },
        { "LinkPreloadResponsiveImagesEnabled", &WebPreferences::setLinkPreloadResponsiveImagesEnabled },
        { "LinkPrefetchEnabled", &WebPreferences::setLinkPrefetchEnabled },
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
        { "MaskWebGLStringsEnabled", &WebPreferences::setMaskWebGLStringsEnabled },
#endif
        { "CoreMathMLEnabled", &WebPreferences::setCoreMathMLEnabled },
        { "MediaCapabilitiesExtensionsEnabled", &WebPreferences::setMediaCapabilitiesExtensionsEnabled },
#if ENABLE(MEDIA_SESSION)
        { "MediaSessionEnabled", &WebPreferences::setMediaSessionEnabled },
#endif
#if ENABLE(MEDIA_STREAM)
        { "MediaRecorderEnabled", &WebPreferences::setMediaRecorderEnabled },
#endif
#if ENABLE(WEB_AUDIO)
        { "ModernUnprefixedWebAudioEnabled", &WebPreferences::setModernUnprefixedWebAudioEnabled },
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
        { "IsNSURLSessionWebSocketEnabled", &WebPreferences::setIsNSURLSessionWebSocketEnabled },
#endif
#if ENABLE(OPUS)
        { "OpusDecoderEnabled", &WebPreferences::setOpusDecoderEnabled },
#endif
        { "PaintTimingEnabled", &WebPreferences::setPaintTimingEnabled },
        { "PrivateClickMeasurementDebugModeEnabled", &WebPreferences::setPrivateClickMeasurementDebugModeEnabled },
        { "PrivateClickMeasurementFraudPreventionEnabled", &WebPreferences::setPrivateClickMeasurementFraudPreventionEnabled },
        { "GoogleAntiFlickerOptimizationQuirkEnabled", &WebPreferences::setGoogleAntiFlickerOptimizationQuirkEnabled },
        { "ReadableByteStreamAPIEnabled", &WebPreferences::setReadableByteStreamAPIEnabled },
        { "ReferrerPolicyAttributeEnabled", &WebPreferences::setReferrerPolicyAttributeEnabled },
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
        { "RemotePlaybackEnabled", &WebPreferences::setRemotePlaybackEnabled },
#endif
#if ENABLE(RESIZE_OBSERVER)
        { "ResizeObserverEnabled", &WebPreferences::setResizeObserverEnabled },
#endif
        { "IsSameSiteStrictEnforcementEnabled", &WebPreferences::setIsSameSiteStrictEnforcementEnabled },
#if ENABLE(MEDIA_STREAM)
        { "ScreenCaptureEnabled", &WebPreferences::setScreenCaptureEnabled },
#endif
        { "ServerTimingEnabled", &WebPreferences::setServerTimingEnabled },
        { "SpeechRecognitionEnabled", &WebPreferences::setSpeechRecognitionEnabled },
        { "ProcessSwapOnCrossSiteNavigationEnabled", &WebPreferences::setProcessSwapOnCrossSiteNavigationEnabled },
        { "SyntheticEditingCommandsEnabled", &WebPreferences::setSyntheticEditingCommandsEnabled },
        { "TransformStreamAPIEnabled", &WebPreferences::setTransformStreamAPIEnabled },
        { "UserGesturePromisePropagationEnabled", &WebPreferences::setUserGesturePromisePropagationEnabled },
#if ENABLE(VP9)
        { "VP8DecoderEnabled", &WebPreferences::setVP8DecoderEnabled },
#endif
#if ENABLE(VP9)
        { "VP9SWDecoderEnabledOnBattery", &WebPreferences::setVP9SWDecoderEnabledOnBattery },
#endif
#if ENABLE(VP9)
        { "VP9DecoderEnabled", &WebPreferences::setVP9DecoderEnabled },
#endif
        { "VisualViewportAPIEnabled", &WebPreferences::setVisualViewportAPIEnabled },
#if ENABLE(VORBIS)
        { "VorbisDecoderEnabled", &WebPreferences::setVorbisDecoderEnabled },
#endif
        { "WebAnimationsCompositeOperationsEnabled", &WebPreferences::setWebAnimationsCompositeOperationsEnabled },
        { "WebAnimationsMutableTimelinesEnabled", &WebPreferences::setWebAnimationsMutableTimelinesEnabled },
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationModernEnabled", &WebPreferences::setWebAuthenticationModernEnabled },
#endif
#if ENABLE(WEB_AUTHN)
        { "WebAuthenticationEnabled", &WebPreferences::setWebAuthenticationEnabled },
#endif
        { "WebShareFileAPIEnabled", &WebPreferences::setWebShareFileAPIEnabled },
#if ENABLE(WEB_AUDIO)
        { "AudioWorkletEnabled", &WebPreferences::setAudioWorkletEnabled },
#endif
#if ENABLE(WEBGL2)
        { "WebGL2Enabled", &WebPreferences::setWebGL2Enabled },
#endif
#if ENABLE(WEBGPU)
        { "WebGPUEnabled", &WebPreferences::setWebGPUEnabled },
#endif
#if ENABLE(MEDIA_SOURCE) && ENABLE(VP9)
        { "WebMParserEnabled", &WebPreferences::setWebMParserEnabled },
#endif
#if ENABLE(WEBM_FORMAT_READER)
        { "WebMFormatReaderEnabled", &WebPreferences::setWebMFormatReaderEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH264LowLatencyEncoderEnabled", &WebPreferences::setWebRTCH264LowLatencyEncoderEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCH265CodecEnabled", &WebPreferences::setWebRTCH265CodecEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCInsertableStreamsEnabled", &WebPreferences::setWebRTCInsertableStreamsEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCPlatformCodecsInGPUProcessEnabled", &WebPreferences::setWebRTCPlatformCodecsInGPUProcessEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCPlatformSocketsEnabled", &WebPreferences::setWebRTCPlatformSocketsEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP9Profile0CodecEnabled", &WebPreferences::setWebRTCVP9Profile0CodecEnabled },
#endif
#if ENABLE(WEB_RTC)
        { "WebRTCVP9Profile2CodecEnabled", &WebPreferences::setWebRTCVP9Profile2CodecEnabled },
#endif
#if ENABLE(WEBXR)
        { "WebXREnabled", &WebPreferences::setWebXREnabled },
#endif
        { "WheelEventGesturesBecomeNonBlocking", &WebPreferences::setWheelEventGesturesBecomeNonBlocking },
        { "PassiveWheelListenersAsDefaultOnDocument", &WebPreferences::setPassiveWheelListenersAsDefaultOnDocument },
        { "WritableStreamAPIEnabled", &WebPreferences::setWritableStreamAPIEnabled },
        { "RequestIdleCallbackEnabled", &WebPreferences::setRequestIdleCallbackEnabled },
    };

    for (auto& setter : setters) {
        if (key == setter.name) {
            (this->*setter.function)(value);
            return;
        }
    }
}

void WebPreferences::enableAllExperimentalFeatures()
{
    UpdateBatch batch(*this);
    setFocusVisibleEnabled(true);
    setPageAtRuleSupportEnabled(true);
    setAccessibilityObjectModelEnabled(true);
#if ENABLE(MEDIA_STREAM)
    setPerElementSpeakerSelectionEnabled(true);
#endif
#if ENABLE(MEDIA_STREAM)
    setExposeSpeakersEnabled(true);
#endif
    setAspectRatioOfImgFromWidthAndHeightEnabled(true);
    setAsyncClipboardAPIEnabled(true);
    setHTTPSUpgradeEnabled(true);
    setBlankAnchorTargetImpliesNoOpenerEnabled(true);
    setThirdPartyIframeRedirectBlockingEnabled(true);
    setAspectRatioEnabled(true);
    setCSSCustomPropertiesAndValuesEnabled(true);
    setCSSIndividualTransformPropertiesEnabled(true);
    setOverscrollBehaviorEnabled(true);
#if ENABLE(CSS_PAINTING_API)
    setCSSPaintingAPIEnabled(true);
#endif
    setCSSRelativeColorSyntaxEnabled(true);
    setSpringTimingFunctionEnabled(true);
#if ENABLE(CSS_TYPED_OM)
    setCSSTypedOMEnabled(true);
#endif
    setCSSColorMixEnabled(true);
    setCSSOMViewSmoothScrollingEnabled(true);
    setContactPickerAPIEnabled(true);
#if ENABLE(CORE_IMAGE_ACCELERATED_FILTER_RENDER)
    setCoreImageAcceleratedFilterRenderEnabled(true);
#endif
    setShouldDeferAsynchronousScriptsUntilAfterDocumentLoadOrFirstPaint(true);
    setDialogElementEnabled(true);
    setIsThirdPartyCookieBlockingDisabled(true);
#if HAVE(CELESTIAL)
    setDisableMediaExperiencePIDInheritance(true);
#endif
    setIsFirstPartyWebsiteDataRemovalDisabled(true);
    setWebSQLDisabled(true);
    setDisallowSyncXHRDuringPageDismissalEnabled(true);
#if HAVE(NETWORK_LOADER)
    setCFNetworkNetworkLoaderEnabled(true);
#endif
    setFetchAPIKeepAliveEnabled(true);
#if ENABLE(GPU_PROCESS) && !USE(GSTREAMER)
    setUseGPUProcessForMediaEnabled(true);
#endif
#if ENABLE(VIDEO)
    setGenericCueAPIEnabled(true);
#endif
    setHDRMediaCapabilitiesEnabled(true);
#if ENABLE(MODEL_ELEMENT)
    setModelElementEnabled(true);
#endif
#if HAVE(CFNETWORK_ALTERNATIVE_SERVICE)
    setHTTP3Enabled(true);
#endif
    setHighlightAPIEnabled(true);
    setImageBitmapEnabled(true);
    setInProcessCookieCacheEnabled(true);
#if HAVE(INCREMENTAL_PDF_APIS)
    setIncrementalPDFLoadingEnabled(true);
#endif
#if ENABLE(INTERSECTION_OBSERVER)
    setIntersectionObserverEnabled(true);
#endif
    setIsLoggedInAPIEnabled(true);
    setLazyIframeLoadingEnabled(true);
    setLazyImageLoadingEnabled(true);
    setLinkPreloadResponsiveImagesEnabled(true);
    setLinkPrefetchEnabled(true);
#if ENABLE(WEBGL) || ENABLE(WEBGL2)
    setMaskWebGLStringsEnabled(true);
#endif
    setCoreMathMLEnabled(true);
    setMediaCapabilitiesExtensionsEnabled(true);
#if ENABLE(MEDIA_SESSION)
    setMediaSessionEnabled(true);
#endif
#if ENABLE(MEDIA_STREAM)
    setMediaRecorderEnabled(true);
#endif
#if ENABLE(WEB_AUDIO)
    setModernUnprefixedWebAudioEnabled(true);
#endif
#if HAVE(NSURLSESSION_WEBSOCKET)
    setIsNSURLSessionWebSocketEnabled(true);
#endif
#if ENABLE(OPUS)
    setOpusDecoderEnabled(true);
#endif
    setPaintTimingEnabled(true);
    setPrivateClickMeasurementDebugModeEnabled(true);
    setPrivateClickMeasurementFraudPreventionEnabled(true);
    setGoogleAntiFlickerOptimizationQuirkEnabled(true);
    setReadableByteStreamAPIEnabled(true);
    setReferrerPolicyAttributeEnabled(true);
#if ENABLE(WIRELESS_PLAYBACK_TARGET)
    setRemotePlaybackEnabled(true);
#endif
#if ENABLE(RESIZE_OBSERVER)
    setResizeObserverEnabled(true);
#endif
    setIsSameSiteStrictEnforcementEnabled(true);
#if ENABLE(MEDIA_STREAM)
    setScreenCaptureEnabled(true);
#endif
    setServerTimingEnabled(true);
    setSpeechRecognitionEnabled(true);
    setProcessSwapOnCrossSiteNavigationEnabled(true);
    setSyntheticEditingCommandsEnabled(true);
    setTransformStreamAPIEnabled(true);
    setUserGesturePromisePropagationEnabled(true);
#if ENABLE(VP9)
    setVP8DecoderEnabled(true);
#endif
#if ENABLE(VP9)
    setVP9SWDecoderEnabledOnBattery(true);
#endif
#if ENABLE(VP9)
    setVP9DecoderEnabled(true);
#endif
    setVisualViewportAPIEnabled(true);
#if ENABLE(VORBIS)
    setVorbisDecoderEnabled(true);
#endif
    setWebAnimationsCompositeOperationsEnabled(true);
    setWebAnimationsMutableTimelinesEnabled(true);
#if ENABLE(WEB_AUTHN)
    setWebAuthenticationModernEnabled(true);
#endif
#if ENABLE(WEB_AUTHN)
    setWebAuthenticationEnabled(true);
#endif
    setWebShareFileAPIEnabled(true);
#if ENABLE(WEB_AUDIO)
    setAudioWorkletEnabled(true);
#endif
#if ENABLE(WEBGL2)
    setWebGL2Enabled(true);
#endif
#if ENABLE(WEBGPU)
    setWebGPUEnabled(true);
#endif
#if ENABLE(MEDIA_SOURCE) && ENABLE(VP9)
    setWebMParserEnabled(true);
#endif
#if ENABLE(WEBM_FORMAT_READER)
    setWebMFormatReaderEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCH264LowLatencyEncoderEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCH265CodecEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCInsertableStreamsEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCPlatformCodecsInGPUProcessEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCPlatformSocketsEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCVP9Profile0CodecEnabled(true);
#endif
#if ENABLE(WEB_RTC)
    setWebRTCVP9Profile2CodecEnabled(true);
#endif
#if ENABLE(WEBXR)
    setWebXREnabled(true);
#endif
    setWheelEventGesturesBecomeNonBlocking(true);
    setPassiveWheelListenersAsDefaultOnDocument(true);
    setWritableStreamAPIEnabled(true);
    setRequestIdleCallbackEnabled(true);
}

}
